# frozen_string_literal: true

require 'bundler/gem_tasks'
require 'rake/testtask'

Rake::TestTask.new(:test) do |t|
  t.warning = false
  t.test_files = FileList["test/**/*_test.rb"]
end

GENERATED_PARSER = 'lib/gitlab-zoql/parser/parser.racc.rb'
GENERATED_LEXER = 'lib/gitlab-zoql/parser/parser.rex.rb'

file GENERATED_LEXER => 'lib/gitlab-zoql/parser/parser.rex' do |t|
  sh "rex -o #{t.name} #{t.prerequisites.first}"
end

file GENERATED_PARSER => 'lib/gitlab-zoql/parser/parser.racc' do |t|
  sh "racc -o #{t.name} #{t.prerequisites.first}"
end

task parser: [GENERATED_LEXER, GENERATED_PARSER]
task default: [:test]

# Make sure the parser's up-to-date when we test.
Rake::Task['test'].prerequisites << :parser
